program RaxPic;
uses DOS;

const
HexChars : Array[0..15] of Char = '0123456789ABCDEF';
BinPosis : Array[1..14] of Byte = (1,2, 4,5,6,7, 9,10,11,12, 14,15,16,17);

var
  EF : Text;
  AF : Text;
  BF : File;
  S  : String;

  W  : Array[0..$2FFF] of Word;
  B  : Array[0..$4FFE] of Byte absolute W;
  U  : Array[0..$2FFF] of boolean;
  N  : PathStr;
  AN : PathStr;
  BN : PathStr;

  Dir : DirStr;
  Name: NameStr;
  Ext : ExtStr;

  Adp : Word;
  By  : Byte;
  Le  : Word;
  Sp  : Word;
  J   : Word;
  Fen : Boolean;
  Line: Integer;



function  Hex(N: Byte): Char;
begin
  Hex:= HexChars[N and 15];
end;

function  HexByte(B: Byte): String;
begin
  HexByte:= Hex(B shr 4) + Hex(B);
end;

function  HexWord(W: Word): String;
begin
  HexWord:= Hex(W shr 12) + Hex(W shr 8) + Hex(W shr 4) + Hex(W);
end;

function  BinWord(W: Word): String;
var J: Integer;
    S: String[17];
    H: Word;
begin
  S:= '00 0000 0000 0000';
  H:= $2000;
  for J:= 1 to 14 do
  begin
    if (W and H) <> 0 then inc(S[BinPosis[J]]);
    H:= H shr 1;
  end;
  BinWord:= S;
end;



function FileExists(var T: Text; FileName: string) : Boolean;
var J: Word;
begin
  {$I-}
  Assign(T, FileName);
  Reset(T);
  J:= IOResult;
  if FileName = '' then Close(T);
  {$I+}
  FileExists := (J = 0) and (FileName <> '');
end;  { FileExists }

Procedure Fehler(Was: String);
begin
  writeln;
  writeln(S);
  writeln(Was);
  halt(99);
end;


Function GetHex: Byte;
var
  C   : Char;
  Byt : Byte;
begin
  if Sp>Length(S) then Fehler('Zeilenende zu frh');
  C:= Upcase(S[Sp]);
  inc(Sp);
  if C in ['0'..'9']
  then begin
         Byt:= ord(C) - ord('0');
         GetHex:= Byt and 15;
         exit;
       end;
  if C in ['A'..'F']
  then begin
         Byt:= ord(C) - ord('A') + 10;
         GetHex:= Byt and 15;
         exit;
       end;
  Fehler('kein Hex-Zeichen!');
end;

Function GetByte: Byte;
var Wd: Word;
begin
  Wd:= GetHex;
  Wd:= Wd shl 4;
  Wd:= Wd or GetHex;
  GetByte:= Wd and 255;
end;


Function Instruction(Bef: Word): String;
var I     : Word;
    wohin : Char;
begin
  if Bef and $3800 = $2800
  then begin
         Instruction:= 'GOTO   '+HexWord(Bef and $7FF)+'H';
         exit;
       end;

  if Bef and $3800 = $2000
  then begin
         Instruction:= 'CALL   '+HexWord(Bef and $7FF)+'H';
         exit;
       end;

  if Bef and $3F9F = 0
  then begin
         Instruction:= 'NOP';
         exit;
       end;

  if Bef and $3F80 = $0100
  then begin
         Instruction:= 'CLRW';
         exit;
       end;

  if Bef and $3FFF = $0009
  then begin
         Instruction:= 'RETFIE';
         exit;
       end;

  if Bef and $3FFF = $0008
  then begin
         Instruction:= 'RETURN';
         exit;
       end;

  if Bef and $3FFF = $0063
  then begin
         Instruction:= 'SLEEP';
         exit;
       end;

  if Bef and $3FFF = $0062
  then begin
         Instruction:= 'OPTION';
         exit;
       end;

  if Bef and $3FFF = $0064
  then begin
         Instruction:= 'CLRWDT';
         exit;
       end;

  if Bef and $3F80 = $0180
  then begin
         Instruction:= 'CLRF   '+HexByte(Bef and $7F)+'H';
         exit;
       end;

  if Bef and $3F80 = $0080
  then begin
         Instruction:= 'MOVWF  '+HexByte(Bef and $7F)+'H';
         exit;
       end;

  if Bef and $80 = 0 then wohin:= 'W' else wohin:= 'F';

  if Bef and $3F00 = $0700
  then begin
         Instruction:= 'ADDWF  '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0500
  then begin
         Instruction:= 'ANDWF  '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0900
  then begin
         Instruction:= 'COMF   '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0300
  then begin
         Instruction:= 'DECF   '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0B00
  then begin
         Instruction:= 'DECFSZ '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0A00
  then begin
         Instruction:= 'INCF   '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0F00
  then begin
         Instruction:= 'INCFSZ '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0400
  then begin
         Instruction:= 'IORWF  '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0800
  then begin
         Instruction:= 'MOVF   '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0D00
  then begin
         Instruction:= 'RLF    '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0C00
  then begin
         Instruction:= 'RRF    '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0200
  then begin
         Instruction:= 'SUBWF  '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0E00
  then begin
         Instruction:= 'SWAPF  '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $0600
  then begin
         Instruction:= 'XORWF  '+HexByte(Bef and $7F)+'H, '+wohin;
         exit;
       end;

  if Bef and $3F00 = $3900
  then begin
         Instruction:= 'ANDLW  '+HexByte(Bef and $FF)+'H';
         exit;
       end;

  if Bef and $3F00 = $3800
  then begin
         Instruction:= 'IORLW  '+HexByte(Bef and $FF)+'H';
         exit;
       end;

  if Bef and $3F00 = $3A00
  then begin
         Instruction:= 'XORLW  '+HexByte(Bef and $FF)+'H';
         exit;
       end;

  if Bef and $3E00 = $3E00
  then begin
         Instruction:= 'ADDLW  '+HexByte(Bef and $FF)+'H';
         exit;
       end;

  if Bef and $3E00 = $3C00
  then begin
         Instruction:= 'SUBLW  '+HexByte(Bef and $FF)+'H';
         exit;
       end;

  if Bef and $3C00 = $3000
  then begin
         Instruction:= 'MOVLW  '+HexByte(Bef and $FF)+'H';
         exit;
       end;

  if Bef and $3C00 = $3400
  then begin
         Instruction:= 'RETLW  '+HexByte(Bef and $FF)+'H';
         exit;
       end;

  if Bef = $1803
  then begin
         Instruction:= 'SKIP   NC';
         exit;
       end;

  if Bef = $1C03
  then begin
         Instruction:= 'SKIP   C';
         exit;
       end;

  if Bef = $1883
  then begin
         Instruction:= 'SKIP   NDIGC';
         exit;
       end;

  if Bef = $1C83
  then begin
         Instruction:= 'SKIP   DIGC';
         exit;
       end;

  if Bef = $1903
  then begin
         Instruction:= 'SKIP   NZ';
         exit;
       end;

  if Bef = $1D03
  then begin
         Instruction:= 'SKIP   Z';
         exit;
       end;

  if Bef and $3C00 = $1000
  then begin
         Instruction:= 'BCF    '+
                       HexByte(Bef and $7F)+'H, '+
                       HexByte((Bef shr 7) and 7);
         exit;
       end;

  if Bef and $3C00 = $1400
  then begin
         Instruction:= 'BSF    '+
                       HexByte(Bef and $7F)+'H, '+
                       HexByte((Bef shr 7) and 7);
         exit;
       end;

  if Bef and $3C00 = $1800
  then begin
         Instruction:= 'BTFSC  '+
                       HexByte(Bef and $7F)+'H, '+
                       HexByte((Bef shr 7) and 7);
         exit;
       end;

  if Bef and $3C00 = $1C00
  then begin
         Instruction:= 'BTFSS  '+
                       HexByte(Bef and $7F)+'H, '+
                       HexByte((Bef shr 7) and 7);
         exit;
       end;

  if Bef and $3FF8 = $0060
  then begin
         Instruction:= 'TRIS   '+HexByte(Bef and $7);
         exit;
       end;



  Instruction:= '???';
end;


procedure doOrg(A : Word);
begin
  writeln(AF,' ':22,Line:5);
  inc(Line);
  writeln(AF,HexWord(A),' ':18,Line:5,'     ORG    ',A);
  inc(Line);
end;

procedure doRaz(A : Word; Bef : Word);
begin
  writeln(AF,HexWord(A),' ',BinWord(Bef),Line:5,'     ',Instruction(Bef));
  inc(Line);
end;




begin
   if ParamCount=0
  then
     begin
       write('Name PIC-HEX-Datei : ');
       readln(N);
       if N='' then
       begin
         writeln('PIC-16C71 Reassembler');
         writeln('usage:  RAXPIC Hexdatei');
         exit;
       end;
     end
  else N:= ParamStr(1);

  FSplit(N, Dir, Name, Ext);
  if (Ext='') or (Ext='.') then Ext:= '.OBJ';
  N:= Dir+Name+Ext;
  AN:= Dir+Name+'.RAX';
  BN:= Dir+Name+'.RBX';

  if not FileExists(EF,N) then
  begin
    Writeln('Datei ',N,' nicht gefunden');
    exit;
  end;

  FillChar(W,SizeOf(W),$FF);
  FillChar(U,SizeOf(U),false);

  Fen:= false;
  Line:= 1;
  while (not EOF(EF)) and (not Fen) do
  begin
    readln(EF,S);
    Sp:= 1;
    while (Sp<Length(S)) and (S[Sp]<>':') do inc(Sp);
    if S[Sp]<>':' then Fehler('kein ":"');
    inc(Sp);
    Le:= GetByte;
    Adp:= GetByte;
    Adp:= (Adp shl 8) or GetByte;
    By:= GetByte;
    if By=1
    then Fen:= true
    else
    begin
      for J:= 1 to Le do
      begin
        By:= GetByte;
        if Adp>$4FFE then Fehler('Adr auer Bereich');
        B[Adp]:= By;
        U[Adp shr 1]:= true;
        inc(Adp);
      end;
    end;
  end;
  Close(EF);

  { nun reassemblieren }
  Fen:= true;
  Assign(AF,AN);
  rewrite(AF);
  for J:= 0 to $2FFF do
  begin
    if Fen and U[J]
    then begin
           doOrg(J);
           Fen:= false;
         end;
    if U[J] then doRaz(J,W[J])
            else Fen:= true;
  end;
  Close(AF);
  Assign(BF,BN);
  Rewrite(BF,1);
  BlockWrite(BF,W, SizeOf(W));
  Writeln('..fertig');
  Close(BF);
end.
